/* Formatted on 2007/11/19 00:17 (Formatter Plus v4.8.8) */

set echo on


-- ==================
-- Initialisation
-- ==================
DROP TABLE tab1;
DROP TABLE tab2;
CREATE TABLE tab1 AS SELECT ROWNUM pk, 999999 skewed , a.* 
  FROM dba_objects a, (select * from dual connect by level <=10) b;


-- Only three rows with numbers other than '999999'
UPDATE tab1
   SET skewed = rownum
 WHERE ROWNUM < 4;
 
COMMIT ;

SELECT   skewed,
         COUNT (*) c
    FROM tab1
GROUP BY skewed
ORDER by skewed;

CREATE UNIQUE INDEX tab1_idx1 ON tab1(PK);
CREATE INDEX tab1_idx2 ON tab1(skewed);


-- Now lets examine TAB1's  Statistics
EXEC dbms_stats.gather_table_stats( user, 'TAB1')
-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

PAUSE Look at base statistics.  No histogram statistics (USER_TAB_COL_STATISTICS.HISTOGRAM is NULL) but there are 2 entries in the USER_HISTOGRAMS table.








-- Generate Hitogram.  
-- Results are not accurate.  See USER_TAB_COL_STATISTCS.NUMBER_DISTINCT for TAB1.SKEWED column
EXEC dbms_stats.gather_table_stats( user, 'TAB1', method_opt=>'for all indexed columns',cascade=>true);

-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

PAUSE Note:  Stats are not as accurate as expected. 
PAUSE See USER_TAB_COL_STATISTCS.NUMBER_DISTINCT for TAB1.SKEWED column
PAUSE Look at USER_TAB_COL_STATISTICS.HISTOGRAM 









-- Results are more accurate.  See USER_TAB_COL_STATISTICS.NUMBER_DISTINCT
EXEC dbms_stats.gather_table_stats( user, 'TAB1', ESTIMATE_PERCENT=>100, method_opt=>'for all indexed columns',cascade=>true);

-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

PAUSE With 100% Sample, we have accurate information









-- =================================================================
-- Demonstrate FREQUENCY vs HEIGHT_BALANCED when NDV < NUM_Buckets.  
-- =================================================================
-- Use default estimate %
EXEC dbms_stats.gather_table_stats(user,'TAB1',method_opt=>'FOR COLUMNS SIZE 2 SKEWED')

-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

PAUSE From user_tab_col_statistics(estimate), for SKEWED column NDV = 1, Bucket = 1 and Histogram = FREQUENCY








-- Now use COMPUTE
EXEC dbms_stats.gather_table_stats(user,'TAB1',ESTIMATE_PERCENT=>100,method_opt=>'FOR COLUMNS SIZE 2 SKEWED')

-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

PAUSE From user_tab_col_statistics(COMPUTE), for SKEWED column NDV = 4, Bucket = 2 and Histogram = HEIGHT BALANCED








-- Lets increase # of buckets to 10
EXEC dbms_stats.gather_table_stats(user,'TAB1',ESTIMATE_PERCENT=>100,method_opt=>'FOR COLUMNS SIZE 10 SKEWED')


-- Edit display_stats as per your environment and uncomment following line
-- @display_stats

-- From user_tab_col_statistics, for SKEWED column NDV = 4, Bucket = 4 and Histogram = FREQUENCY
PAUSE Note it is now a FREQUENCY histogram with Bucket =  4



