set timing on
set echo on

SELECT   skewed,
         COUNT (*)
    FROM tab1
GROUP BY skewed
ORDER BY skewed;

EXEC dbms_stats.delete_table_stats(user,'TAB1')

EXEC dbms_stats.gather_table_stats( user, 'TAB1', ESTIMATE_PERCENT=>100, method_opt=>'for all indexed columns',cascade=>true);


--  Index has stats.  Table none

VAR s NUMBER;

ALTER SYSTEM FLUSH SHARED_POOL;
ALTER SESSION SET sql_trace=TRUE;

PAUSE 

-- No BV.
SELECT SUM (pk + skewed)
  FROM tab1
 WHERE skewed = 1;


PAUSE 

-- No BV.
SELECT SUM (pk + skewed)
  FROM tab1
 WHERE skewed = 999999;


PAUSE 

-- BV with value of 1
EXEC :s := 1;

SELECT SUM (pk + skewed) first_bv_is_1
  FROM tab1
 WHERE skewed = :s;


PAUSE 

-- BV with value of 999999
EXEC :s := 999999;


-- Identical SQL
SELECT SUM (pk + skewed) first_bv_is_1
  FROM tab1
 WHERE skewed = :s;


-- When using bind variable, TKPROF DOES NOT PEEK - it thinks there are 60k rows/4 NDV evenly distributes values
-- Execution plan does peek and chooses optimal Idx Range Scan when BV :s = 1.
-- but when BV :s = 999999,, ,it should be FTS but is it?

Pause


-- Flush Shared Pool and start fromm scratch
ALTER SYSTEM FLUSH SHARED_POOL;

-- Start with BV = 999999
EXEC :s := 999999;

SELECT SUM (pk + skewed) first_bv_is_999999
  FROM tab1
 WHERE skewed = :s;


Pause

EXEC :s := 1;

-- Identical SQL with new BV value of 1
SELECT SUM (pk + skewed) first_bv_is_999999
  FROM tab1
 WHERE skewed = :s;



ALTER SESSION SET sql_trace=FALSE;




