col table_name format a15
col column_name format a15
col index_owner format a15
col owner_owner format a15
-- SQL to identify columns that were used in a predicate
SELECT r.NAME owner_name,
       o.NAME table_name,
       c.NAME column_name,
       equality_preds,
       equijoin_preds,
       nonequijoin_preds,
       range_preds,
       like_preds,
       null_preds,
       TIMESTAMP
  FROM SYS.col_usage$ u, SYS.obj$ o, SYS.col$ c, SYS.user$ r
 WHERE o.obj# = u.obj#
   AND c.obj# = u.obj#
   AND c.col# = u.intcol#
   AND o.owner# = r.user#
   AND (   u.equijoin_preds > 0
        OR u.nonequijoin_preds > 0)
   AND r.NAME = 'TJAMBU'
/

--  SQL to identify cols in predicate that are not in indexes

SELECT r.NAME index_owner,
       o.NAME table_name,
       c.NAME column_name
  FROM SYS.col_usage$ u,
       SYS.obj$ o,
       SYS.col$ c,
       SYS.user$ r
 WHERE o.obj# = u.obj#
   AND c.obj# = u.obj#
   AND c.col# = u.intcol#
   AND o.owner# = r.user#
   AND (   u.equijoin_preds > 0
        OR u.nonequijoin_preds > 0)
   AND r.NAME = 'TJAMBU'
MINUS
SELECT index_owner,
       table_name,
       column_name
  FROM dba_ind_columns
 WHERE index_owner = 'TJAMBU'
/

